<copyright> 
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright (C) 1996, 1997 Pieter J. Schoenmakers.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: TestLex.t,v 1.8 1998/01/05 17:19:33 tiggr Exp $</id>
    </copyright>

implementation class
TestLex: gps.StreamLexer, TestParseDefines

end;

implementation instance
TestLex
{
  <doc> The next character to digest.  </doc>
  int next;
}

<doc> Designated initializer.  </doc>
redefine id
  initWithStream InputStream s
	   named String n
{
  /* Setup the next character to be read.  Having this single look-ahead
     removes the need for the lexer to stuff characters back into the
     stream.  */
  next = [s read];

  /* Let our superclass (gps.StreamLexer in this case) finish our
     initialization.  */
  = [super initWithStream s named n];
}

<doc> Read and return the next token.  This will set the (inherited)
    {semantics} variable.  </doc>
int
  nextToken
{
  semantics = nil;

  /* Skip any whitespace.  */
  while (next == ' ' || next == '\t')
    next = [stream read];

  if ((next >= 'a' && next <= 'z') || (next >= 'A' && next <= 'Z'))
    {
      MutableByteString s = [MutableByteString new];

      do
	{
	  [s add byte (next)];
	  next = [stream read];
	} while ((next >= 'a' && next <= 'z')
		 || (next >= 'A' && next <= 'Z')
		 || (next >= '0' && next <= '9') || next == '_');

      semantics = Any (s);
      token = IDENTIFIER;
    }
  else if (next >= '0' && next <= '9')
    {
      int value;

      do
	{
	  value = 10 * value + next - '0';
	  next = [stream read];
	} while (next >= '0' && next <= '9');

      semantics = Any ([IntNumber with value]);
      token = NUMBER;
    }
  else if (next == -1)
    token = 0;
  else if (next == '\n')
    {
      current_line++;
      next = [stream read];
      token = [self nextToken];
    }
  else
    {
      token = next;
      next = [stream read];
    }

  = token;
}

end;
