implementation class
Element: State, gp, ParserDefines, GPParseDefines, FileElement
{
  <doc> The current run...  </doc>
  static int current_run;
}

int
  next_run
{
  = ++current_run;
}

<doc> Return a condition deciding whether the token matches the tokens
    returned by {e}.  </doc>
String
  condition Enumerator e
{
  MutableByteString s = [MutableByteString new];
  boolean b, first = YES;
  int token;

  // GGG On m68k-next-nextstep3, GCC 2.7.2.1 Objective-C snapshot 960906
  // this will fail when written as `while ({(b, token) = [e next]; b;})'.
  //
  // The code output for the test of B is:
  //	tstb d0
  // 	seq d0
  // 	bne out_of_the_loop
  //
  // Note that the value of D0 is used later on for manipulating FIRST.
  while ({(b, token) = [e next]; b == TRUE;})
    {
      if (first)
	{
	  first = NO;
	  [s print '('];
	}
      else
	[s print " || "];

      [self name [s print "token == "] token token];
    }

  if (first)
    [s print "(1"];
  [s print ')'];

  = s;
}

OutputStream
   name OutputStream s
  token int token
{
  = ({if (token >= ' ' && token <= '~')
      {
	if (token == '\\' || token == '\'')
	  [s print ('\'', '\\', byte (token), '\'')];
	else
	  [s print ('\'', byte (token), '\'')];
      }
    else if (token >= 65536)
      {
	String n = [GPParse ([GPParse current_parser])
		     gp_tokens_by_number][token - 65536];

	[s print n];
      }
    else
      [s print token];});
}

end;

/******************** instance Element ********************/

implementation instance
Element
{
  <doc> The first, look-ahead, and follow sets.  </doc>
  public IntegerRangeSet first, la, follow;

  <doc> The computation run in which we've last been updated.  </doc>
  int run;

  <doc> The line in the file at which we reside.  </doc>
  public int line;

  <doc> Least-cost insertion, element of the S-table.  </doc>
  public mutable Sequence S-element;
}

<doc> Designated initializer.  </doc>
id
  init
{
  line = [[[Parser current_parser] lex] current_line];
//  S-element = [[Sequence alloc] init];
  = self;
}

<doc> Check LL(1)-ness of the receiving element.  </doc>
deferred void
  checkLL1;

deferred int
  cost;

<doc> Output code for parsing the receiving element.  </doc>
OutputStream
  compile OutputStream s
{
  = [self compile s withAttributes nil];
}

OutputStream
	 compile OutputStream s
  withAttributes Array actual
{
  [self shouldNotImplement cmd];
}

<doc> Compute and return the look-ahead set of the receiving element, given
    the follow set {follow}.  This computes all three significant sets of
    the receiving element.  </doc>
deferred IntegerRangeSet
  computeLA IntegerRangeSet follow;

<doc> Describe the receiving {Element} to the stream {s}.  The default
    implementation just prints {self}.  </doc>
OutputStream (s)
  describe-flat-rule OutputStream s
{
  [s print self];
}

<doc> Return the replacement for the receiving {Element} for use in a
    flattened rule with the name {rule_name}.  </doc>
id
  makeFlatRules String rule_name
{
  = self;
}

boolean
  outputBefore Array attributes
{
  = NO;
}

boolean
  isTerminal
{
  = NO;
}

end;
