<copyright> TOM parser generator main.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: gp.t,v 1.13 1998/11/10 17:28:50 tiggr Exp $</id>
    </copyright>

implementation class gp: stdio, Constants
{
  <doc> Control the amount of junk output generated.  </doc>
  static boolean verbose;

  <doc> The parser used to do our job.  </doc>
  static GPParse parser;
}

void
  usage
{
  [[err print ("usage: ", [Runtime program_name],
	       " [-d] [-v] [-o file] [-o dfile] file
verbosity options:
 -v-flat  emit flat rules
 -v-cost  emit non-terminal insertion cost table")] nl];
  [Runtime exit 1];
}

int
  main Array arguments
{
  ByteStream out_defs_file, out_file = ByteStream (out);
  String in_filename, out_filename, out_defs_filename;
  int i, n = [arguments length];

  for (i = 0; i < n; i++)
    {
      String a = arguments[i];

      if (a[0] == '-')
	{
	  if (["-d" equal a])
	    [GPParse set_trace_default YES];
	  else if (["-v" equal a])
	    verbose = YES;
	  else if (["-v-cost" equal a])
	    [GPParse set_verbose_cost TRUE];
	  else if (["-v-flat" equal a])
	    [GPParse set_verbose_flat_rules TRUE];
	  else if (["-o" equal a])
	    if (i < n - 1)
	      {
		a = arguments[++i];
		if (!out_filename)
		  out_filename = a;
		else if (!out_defs_filename)
		  out_defs_filename = a;
		else
		  [self usage];
	      }
	    else
	      [self usage];
	  else
	    [self usage];
	}
      else if (!in_filename)
	in_filename = a;
      else
	[self usage];
    }

  if (!in_filename)
    [self usage];

  GPLex lex = [[GPLex alloc] initWithStream
	       [BufferedStream with [File open in_filename input: YES]]
			     named in_filename];

  parser = [[GPParse alloc] init lex];

  [parser grammar];

  if (out_filename != nil)
    out_file = [File open out_filename output: YES
		     flags: FILE_NOT_EXIST_CREATE];
  if (out_defs_filename != nil)
    out_defs_file = [File open out_defs_filename output: YES
			  flags: FILE_NOT_EXIST_CREATE];

  [parser generate out_file definitions out_defs_file];

  if (verbose)
    [[err print (in_filename, ": ", [lex current_line], " lines")] nl];

  = [parser num_errors];
}

end;

implementation instance gp end;
